#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <signal.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>

/*
	Uso de threads + mutexes + sockets

	Modelação de um parque com "vagas" lugares, ligando para 3330 entra-se (com
possível espera) e para 3331 sai-se. Cliente telnet

*/

int vagas=4;
pthread_mutex_t mut=PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond=PTHREAD_COND_INITIALIZER;

void * carin(void * arg);
void * servein(void * arg);
void * serveout(void * arg);


main(int argc, char *argv[])
{ 
	
	pthread_t tidin;
	pthread_t tidout;

	pthread_create(&tidin,NULL,servein,NULL);
	pthread_create(&tidout,NULL,serveout,NULL);

	pthread_join(tidin,NULL);
	pthread_join(tidout,NULL);
}

void * carin(void * arg)
{
	int confd;

	confd=(int) arg;

	pthread_mutex_lock(&mut);
	printf("Enter: Trying ...\n");
	while(vagas==0) pthread_cond_wait(&cond, &mut);
	vagas--;
	printf("Enter: Vagas=%d\n",vagas);
	pthread_mutex_unlock(&mut);
	close(confd);
	
}

void * servein(void * arg)
{
	pthread_t tid;
	int listfd, confd;
	struct sockaddr_in srv_addr;

	memset(&srv_addr, 0, sizeof(srv_addr));
	srv_addr.sin_family = AF_INET;
	srv_addr.sin_port = htons(3330);
	srv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	listfd = socket(AF_INET, SOCK_STREAM, 0);
	bind(listfd, (struct sockaddr *) &srv_addr, sizeof srv_addr);
	listen(listfd, 5);

	while(1) {
   	confd = accept(listfd, 0, 0);
		pthread_create(&tid,NULL,carin,(void *) confd);
		pthread_detach(tid);
	}


}

void * serveout(void * arg)
{
	int listfd, confd;
	struct sockaddr_in srv_addr;

	memset(&srv_addr, 0, sizeof(srv_addr));
	srv_addr.sin_family = AF_INET;
	srv_addr.sin_port = htons(3331);
	srv_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	listfd = socket(AF_INET, SOCK_STREAM, 0);
	bind(listfd, (struct sockaddr *) &srv_addr, sizeof srv_addr);
	listen(listfd, 5);

	while(1) {
   	confd = accept(listfd, 0, 0);
		pthread_mutex_lock(&mut);
		vagas++;
		printf("Exit: Vagas=%d\n",vagas);
		pthread_mutex_unlock(&mut);
		pthread_cond_broadcast(&cond);
		close(confd);
	}
}


